/*  Example 2:
 *
 *  A recursive and a non-recursive implementation of the factorial
 *  function to demonstrate the tracing mechanism for variables and
 *  function calls.
 *
 *  Hint: The recursive implementation is definitively *not* how one
 *  should write this. It is just meant to have a simple program
 *  everybody understands what it is doing and which does quite a
 *  number of function calls.
 *
 *  Compile this program with "jscc" and execute it with a number
 *  as the argument.
 */
#include <stdio.h>
#include <stdlib.h>

#ifdef __JSFTRACE__
#pragma __JSFTRACE__ vartrace "*" read write
#endif

/*  Prototypes  */
static long factorial_norecur(long arg);
static long factorial_recur(long arg);

int main(int argc, char *argv[])
{
  long i,n;

  if(argc != 2) {
    fprintf(stderr, "Usage: factorial <n>\n");
    return 5;
  }

#ifdef __JSFTRACE__
  /*  This is how one can control tracing without setting environment
   *   variable FUNCTIONTRACE. This is just for the purpose of this
   *   demonstration program where I want to remove the necessity of
   *   setting an environment variable.
   */
  _jstracecontrol("on");
#endif

  i = atoi(argv[1]);

  n = factorial_norecur(i);
  printf("factorial_norecur(%ld) = %ld\n", i, n);

  n = factorial_recur(i);
  printf("factorial_recur(%ld)   = %ld\n", i, n);

  return 0;
}

static long factorial_norecur(long arg)
{
  long i,result;

  result = 1;
  for(i = 1 ; i <= arg ; ++i)
    result *= i;

  return result;
}

static long factorial_recur(long arg)
{
  if(arg <= 1)
    return 1;

  return arg * factorial_recur(arg - 1);
}
