/*  Example 3:
 *
 *  A recursive and a non-recursive implementation of the Fibonacci
 *  numbers.
 *  Hint: The recursive implementation is absolute nonsense, it needs
 *  *exponential* time to execute, whereas the non-recursive
 *  implementation needs only linear time. The whole purpose of the
 *  program is meant for demonstrating the trace facility. I *know*
 *  how to program.
 *
 *  Compile this program with "jscc" and execute it with a number
 *  as the argument.
 */
#include <stdio.h>
#include <stdlib.h>

#ifdef __JSFTRACE__
/*  This pragma enables labels (not on by default)  */
#pragma __JSFTRACE__ trace    "*" call return label
#endif

/*  Prototypes  */
static long fibonacci_norecur(long arg);
static long fibonacci_recur(long arg);

int main(int argc, char *argv[])
{
  long i,n;

  if(argc != 2) {
    fprintf(stderr, "Usage: fibonacci <n>\n");
    return 5;
  }

#ifdef __JSFTRACE__
  /*  This is how one can control tracing without setting environment
   *   variable FUNCTIONTRACE. This is just for the purpose of this
   *   demonstration program where I want to remove the necessity of
   *   setting an environment variable.
   */
  _jstracecontrol("on");
#endif

  i = atoi(argv[1]);

  n = fibonacci_norecur(i);
  printf("fibonacci_norecur(%ld) = %ld\n", i, n);

  n = fibonacci_recur(i);
  printf("fibonacci_recur(%ld)   = %ld\n", i, n);

  return 0;
}

static long fibonacci_norecur(long n)
{
  long i, fibm1, fibm2, fib;

  if(n <= 1)
    return 1;

  fibm1 = fibm2 = 1; /*  for 0 and 1  */

  for(i = 2 ; i <= n ; ++i) {
    fib = fibm1 + fibm2;
    fibm2 = fibm1;
    fibm1 = fib;
  }

  return fib;
}

static long fibonacci_recur(long n)
{
  if(n <= 1)
    return 1;

  return fibonacci_recur(n - 2) + fibonacci_recur(n - 1);
}
