/* ***  Configuration file for different curses versions  *** */
/*  Must be included *after* including "curses.h"  */

#if defined(A_COLOR)
# define CONFIG_HAS_CURSSET /*  Availability of "curs_set()" routine  */

/*  Colors are available, but produce really a mess! Problem is that
 *   colors 0 to 7 are fixed, i.e. 0 is black etc. In the curses
 *   package one *must* specify a color for the character background
 *   and foreground out of 0..7. That means, if your window's background
 *   isn't black, that looks weird!
 */
# define CONFIG_HAS_COLORS   /*  Availability of colors  */
#endif

#if NCURSES_VERSION_PATCH >= 980228
/*  Older versions have a bug: If the window background is set with wbkgd,
 *   color codes are OR'ed resulting in weird colors and no-shadows.
 */
# define CONFIG_USE_SHADOWS
#endif

#if 0 /* no longer true  */
#if defined(_AIX)
/*  This function is missing  */
#define mvwaddnstr(win,line,column,str,len)  \
	mvwprintw(win,line,column,"%.*s",len,str)
#endif
#endif

#ifdef __MSDOS__
/* **  The following definitions work around problems in pccurses  ** */
#define delwin(win)             (delwin(win),OK)
#define touchwin(win)           (touchwin(win),OK)
#define wnoutrefresh(win)       (wnoutrefresh(win),OK)
#define wrefresh(win)           (wrefresh(win),OK)
#define doupdate()              (doupdate(),OK)
#define intrflush(win,bool)     OK

/*  This function is missing  */
#define mvwaddnstr(win,line,column,str,len)  \
	mvwprintw(win,line,column,"%.*s",len,str)
#endif

#ifdef __linux
# define CONFIG_CURSES_USE_ACS
#else
# undef ACS_ULCORNER
# undef ACS_HLINE
# undef ACS_URCORNER
# undef ACS_VLINE
# undef ACS_LLCORNER
# undef ACS_LRCORNER
# undef ACS_CKBOARD
# undef ACS_BLOCK
# undef ACS_LTEE
# undef ACS_RTEE
# undef ACS_BTEE
# undef ACS_TTEE
# undef ACS_PLUS
# undef ACS_LARROW
# undef ACS_RARROW
#endif

/*  For compatibility  */
#ifndef ACS_ULCORNER
# define ACS_ULCORNER  '+'
#endif
#ifndef ACS_HLINE
# define ACS_HLINE     '-'
#endif
#ifndef ACS_URCORNER
# define ACS_URCORNER  '+'
#endif
#ifndef ACS_VLINE
# define ACS_VLINE     '|'
#endif
#ifndef ACS_LLCORNER
# define ACS_LLCORNER  '+'
#endif
#ifndef ACS_LRCORNER
# define ACS_LRCORNER  '+'
#endif
#ifndef ACS_CKBOARD
# define ACS_CKBOARD   '#'
#endif
#ifndef ACS_BLOCK
# define ACS_BLOCK     '#'
#endif
#ifndef ACS_LTEE
# define ACS_LTEE       '+'
#endif
#ifndef ACS_RTEE
# define ACS_RTEE       '+'
#endif
#ifndef ACS_BTEE
# define ACS_BTEE       '+'
#endif
#ifndef ACS_TTEE
# define ACS_TTEE       '+'
#endif
#ifndef ACS_PLUS
# define ACS_PLUS       '+'
#endif
#ifndef ACS_LARROW
# define ACS_LARROW     '-'
#endif
#ifndef ACS_RARROW
# define ACS_RARROW     '-'
#endif
