/*JS*********************************************************************
*
*    Program : JSALLOCA
*    Language: ANSI-C
*    Author  : Joerg Schoen
*    Purpose : Test if 'alloca' is available on a platform and set
*              macro 'CONFIG_USE_ALLOCA'.
*
*              Copyright (C) 1994-2002 Joerg Schoen
*
*   Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*
*************************************************************************/
#ifndef __JSALLOCA_H__
#define __JSALLOCA_H__

#include "jsconfig.h"

#if !defined(CONFIG_NO_ALLOCA) && !defined(USING_DEBUG_ALLOC)
# if defined(__cplusplus)
  /*  Better don't use alloca with C++  */
# elif defined(__linux)
#  define CONFIG_USE_ALLOCA
#  include <alloca.h>  /*  need to include header  */
# elif defined(__sgi)
#  define CONFIG_USE_ALLOCA
#  include <alloca.h>  /*  need to include header  */
# elif defined(_AIX)
#  define CONFIG_USE_ALLOCA
#  pragma alloca       /*  pragma is needed  */
# endif
#endif

#endif
