#ifndef __FCNTL_H_
#define __FCNTL_H_

#include <sys/types.h>

#define O_RDONLY       00
#define O_WRONLY       01
#define O_RDWR	       02

#define O_CREAT      0100
#define O_EXCL	     0200

#define O_TRUNC     01000

#define O_APPEND    02000
#define O_NONBLOCK  04000
#define O_NDELAY    O_NONBLOCK
#define O_SYNC     010000
#define O_DSYNC    O_SYNC
#define O_RSYNC    O_SYNC
#define O_FSYNC    O_SYNC
#define O_ASYNC    020000

#define F_RDLCK 0
#define F_WRLCK 1
#define F_UNLCK 2

#define F_GETLK 3
#define F_SETLK 4
#define F_SETLKW 5

#define F_SETFL  1
#define F_GETFL  2
#define F_DUPFD  3
#define F_SETFD  4
#define F_GETFD  5

struct flock {
  short l_type;
  short l_whence;
  off_t l_start;
  off_t l_len;
  pid_t l_pid;
};

extern int fcntl(int fd, int cmd, ...);

extern int open(const char *pathname, int flags, ...);
extern int creat(const char *pathname, mode_t mode);

#endif
