#ifndef __MATH_H_
#define __MATH_H_

extern double HUGE_VAL;

extern double fabs(double x);
extern double sqrt(double x);
extern double exp(double x);
extern double log(double x);
extern double log10(double x);
extern double frexp(double x, int *argexp);

extern double floor(double x);
extern double pow(double x, double y);
extern double ldexp(double x, int argexp);
extern double ceil(double x);
extern double modf(double x, double *iptr);
extern double fmod(double x, double y);

extern double sin(double x);
extern double cos(double x);
extern double tan(double x);
extern double asin(double x);
extern double acos(double x);
extern double atan(double x);
extern double sinh(double x);
extern double cosh(double x);
extern double tanh(double x);
extern double atan2(double x,double y);

#ifdef JSFTRACE_TRACE_STDLIB
#define fabs _jswrap_fabs
#define sqrt _jswrap_sqrt
#define exp _jswrap_exp
#define log _jswrap_log
#define log10 _jswrap_log10
#define frexp _jswrap_frexp
#define sin _jswrap_sin
#define cos _jswrap_cos
#define tan _jswrap_tan
#define asin _jswrap_asin
#define acos _jswrap_acos
#define atan _jswrap_atan
#define sinh _jswrap_sinh
#define cosh _jswrap_cosh
#define tanh _jswrap_tanh
#define atan2 _jswrap_atan2

#pragma __JSCPP__ expandorig fabs, sqrt, exp, log, log10, frexp, sin, \
	cos, tan, asin, acos, atan, sinh, cosh, tanh, atan2
#endif
#endif
