#ifndef __STRING_H_
#define __STRING_H_

#include <stddef.h>

extern void *memchr(const void *s, int c, size_t n);

extern void *memrchr(const void *s, int c, size_t n);
extern int memcmp(const void *s1, const void *s2, size_t n);
extern void *memcpy(void *dest, const void *src, size_t n);
extern void *memmove(void *dest, const void *src, size_t n);
extern void *memset(void *s, int c, size_t n);

extern int strcmp(const char *s1, const char *s2);

extern int strncmp(const char *s1, const char *s2, size_t n);
extern int strcoll(const char *s1, const char *s2);
extern char *strcpy(char *dest, const char *src);

extern char *strncpy(char *dest, const char *src, size_t n);
extern size_t strspn(const char *s, const char *accept);

extern size_t strcspn(const char *s, const char *reject);
extern char *strerror(int errnum);
extern size_t strlen(const char *s);
extern char *strcat(char *dest, const char *src);
extern char *strncat(char *dest, const char *src, size_t n);
extern char *strpbrk(const char *s, const char *accept);
extern char *strchr(const char *s, int c);
extern char *strrchr(const char *s, int c);
extern char *strstr(const char *haystack, const char *needle);
extern char *strtok(char *s, const char *delim);
extern size_t strxfrm(char *dest, const char *src, size_t n);

extern char *strdup(const char *);

#ifdef __JSCPP__
/*  Produce intelligent warnings in bounds checking  */
#pragma __JSFTRACE__ boundarycheck memchr  array 1 index 3
#pragma __JSFTRACE__ boundarycheck memrchr array 1 index 3
#pragma __JSFTRACE__ boundarycheck memcmp  array 1 index 3
#pragma __JSFTRACE__ boundarycheck memcmp  array 2 index 3
#pragma __JSFTRACE__ boundarycheck memcpy  array 1 index 3
#pragma __JSFTRACE__ boundarycheck memmove array 1 index 3
#pragma __JSFTRACE__ boundarycheck memset  array 1 index 3

#pragma __JSFTRACE__ boundarycheck strncmp array 1 index 3
#pragma __JSFTRACE__ boundarycheck strncmp array 2 index 3
#pragma __JSFTRACE__ boundarycheck strncpy array 1 index 3
#endif

#ifdef JSFTRACE_TRACE_STDLIB
#define memchr _jswrap_memchr
#define memrchr _jswrap_memrchr
#define memcmp _jswrap_memcmp
#define memcpy _jswrap_memcpy
#define memmove _jswrap_memmove
#define memset _jswrap_memset
#define strcmp _jswrap_strcmp
#define strncmp _jswrap_strncmp
#define strcoll _jswrap_strcoll
#define strcpy _jswrap_strcpy
#define strncpy _jswrap_strncpy
#define strspn _jswrap_strspn
#define strcspn _jswrap_strcspn
#define strerror _jswrap_strerror
#define strlen _jswrap_strlen
#define strcat _jswrap_strcat
#define strncat _jswrap_strncat
#define strpbrk _jswrap_strpbrk
#define strchr _jswrap_strchr
#define strrchr _jswrap_strrchr
#define strstr _jswrap_strstr
#define strtok _jswrap_strtok
#define strxfrm _jswrap_strxfrm
#define strdup _jswrap_strdup

#pragma __JSCPP__ expandorig memchr, memrchr, memcmp, memcpy, memmove, \
	memset, strcmp, strncmp, strcoll, strcpy, strncpy, strspn, strcspn, \
	strerror, strlen, strcat, strncat, strpbrk, strchr, strrchr, \
	strstr, strtok, strxfrm, strdup
#endif
#endif
