#ifndef __SYS_MSG_H_
#define __SYS_MSG_H_

#include <sys/ipc.h>
#include <sys/time.h>

struct msqid_ds {
  struct ipc_perm msg_perm;
  time_t          msg_stime;
  time_t          msg_rtime;
  time_t          msg_ctime;
  msgqnum_t       msg_qnum;
  msglen_t        msg_qbytes;
  pid_t           msg_lspid;
  pid_t           msg_lrpid;
};

extern int msgctl(int msqid, int cmd, struct msqid_ds *buf);
extern int msgget(key_t key, int msgflg);
extern int msgsnd(int msqid, struct msgbuf *msgp, size_t msgsz, int msgflg);
extern ssize_t msgrcv(int  msqid, struct msgbuf *msgp, size_t msgsz, long msgtyp,
		      int msgflg);

#endif
