#ifndef __SYS_SEM_H_
#define __SYS_SEM_H_

#include <sys/ipc.h>
#include <sys/time.h>

struct semid_ds {
  struct ipc_perm sem_perm;
  time_t          sem_otime;
  time_t          sem_ctime;
  unsigned short  sem_nsems;
};

#if 0
union semun {
  int              val;
  struct semid_ds *buf;
  unsigned short  *array;
};
#endif

struct sembuf {
  unsigned short sem_num;
  short          sem_op;
  short          sem_flg;
};

#define GETALL       1
#define GETNCNT      2
#define GETPID       3
#define GETVAL       4
#define GETZCNT      5
#define SETALL       6
#define SETVAL       7

#define IPC_NOWAIT   1
#define SEM_UNDO     2

extern int semctl(int semid, int semnum, int cmd, ...);
extern int semget(key_t key, int nsems, int semflg);
extern int semop(int semid, struct sembuf *sops, unsigned nsops);

#endif
