#ifndef __TIME_H_
#define __TIME_H_
#include <stddef.h>

typedef long time_t;
typedef long clock_t;

struct tm {
  int     tm_sec;
  int     tm_min;
  int     tm_hour;
  int     tm_mday;
  int     tm_mon;
  int     tm_year;
  int     tm_wday;
  int     tm_yday;
  int     tm_isdst;
};

extern char *asctime(const struct tm *tm);
extern char *asctime_r(const struct tm *tm, char *buf);

extern char *ctime(const time_t *timep);
extern char *ctime_r(const time_t *timep, char *buf);

extern struct tm *gmtime(const time_t *timep);
extern struct tm *gmtime_r(const time_t *timep, struct tm *result);

extern struct tm *localtime(const time_t *timep);
extern struct tm *localtime_r(const time_t *timep, struct tm *result);

extern time_t mktime(struct tm *tm);

extern time_t time(time_t *t);

extern size_t strftime(char *s, size_t max, const char *format,
		       const struct tm *tm);

extern clock_t clock(void);
extern double difftime(time_t time1, time_t time0);

#endif
