/*  No wrapper since this can be included multiple times!  */
#ifndef __JSPARSE__
# error This doesn't work if not used with "jsparse" library!
#endif

/*  Under GNU, this can be included more than once, sometimes only to
 *   define va_list. So we do not wrap it below.
 */
#include_next <stdarg.h>

#if !defined JSPARSE_STDARG && defined va_arg
#define JSPARSE_STDARG
/*  Save original va_arg.  */
#define_imm _jpavasave(ap,type)  va_arg(ap,type)

/*  Introduce keyword to bracketize "type" so
 *   that our C grammar will accept the
 *   expression
 */
#pragma __JSCPP__ keyword _jpavaprot sizeof

/*  Now redefine va_arg  */
#undef va_arg
#define va_arg(ap,type)           _jpavadefer(ap,_jpavaprot(type))

/*  "_jpavadefer" will be expanded at the end through "_jpavasave"
 *   to it original meaning. Since that happens in two steps and
 *   "_jpavadefer" does nothing special with its second argument,
 *   we can be sure that "_jpavaprot" gets expanded, i. e. removed.
 */
#define _jpavadefer(ap,type)    _jpavasave(ap,type)
#define _jpavaprot(type)         type

/*  Finally, we defer the expansions so that it
 *   looks like a function call to the parser.
 */
#pragma __JSCPP__ defer _jpavadefer, _jpavaprot

/*  Handling of "va_start" and "va_end": To avoid trouble, defer
 *   evaluation.
 */
#pragma __JSCPP__ defer va_start, va_end
#endif
