/*  No wrapper since this can be included multiple times!  */
#ifndef __JSPARSE__
# error This doesn't work if not used with "jsparse" library!
#endif

#if defined offsetof && defined __linux
/*  Save original meaning of macro  */
#undef _jpaoffsetorig
#define_imm _jpaoffsetorig(type,member)      offsetof(type,member)

/*  The GNU library repeatedly redefines it, so we have to clear our definition below  */
#undef offsetof
#undef JSPARSE_STDDEF
#endif

/*  This can be included more than once, so we do not wrap it below  */
#include_next <stddef.h>

/*  Only do the redefining if 'offsetof' has been defined by the
 *   systems "stddef.h".
 */
#if !defined JSPARSE_STDDEF
#if defined offsetof
/*  The macro was defined by GNU's <stddef.h>, so we wrap it a bit  */
#define JSPARSE_STDDEF

/*  Save original meaning of macro  */
#undef _jpaoffsetsave
#define_imm _jpaoffsetsave(type,member)      offsetof(type,member)

/*  Helper macro to make the parser happy. It will disappear at the end  */
#pragma __JSCPP__ keyword _jpaoffsetof        __constant__
#define _jpaoffsetof   /*  empty  */
#pragma __JSCPP__ defer _jpaoffsetof

/*  Now redefine, so the parser only sees a constant and the
 *   original meaning comes as piggyback
 */
#undef offsetof
#define offsetof(type,member)    _jpaoffsetof __ignore__(_jpaoffsetsave(type,member))

#elif defined _jpaoffsetorig
/*  Ok, GNU's <stddef.h> didn't define it again, so restore old meaning  */
#define_imm offsetof(type,member)       _jpaoffsetorig(type,member)

#endif
#endif
