/*JS*********************************************************************
*
*    Program : ANSISYMBOL
*    Language: ANSI-C
*    Author  : Joerg Schoen
*    Purpose : Collect all external symbols of the ANSI standard.
*
*              Copyright (C) 1994-2002 Joerg Schoen
*
*   Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*
*************************************************************************/

/*********     INCLUDES                                         *********/
#include <stdio.h>

#define Prototype extern
/*********     PROTOTYPES                                       *********/
Prototype const char * const ANSISymbols[];

/*********     GLOBAL VARIABLES                                 *********/
/*  It is possible that I forgot something :)  */
const char * const ANSISymbols[] = {
  "stdin",  "stdout", "stderr", "fopen", "freopen", "fflush", "fclose",
  "remove", "rename", "tmpfile", "tmpnam", "setvbuf", "setbuf", "fprintf",
  "printf", "sprintf", "vprintf", "vfprintf", "vsprintf", "fscanf", "scanf",
  "sscanf", "fgetc", "fgets", "fputc", "fputs", "getc", "getchar", "gets",
  "putc", "putchar", "puts", "ungetc", "fread", "fwrite", "fseek", "ftell",
  "rewind", "fgetpos", "fsetpos", "errno", "clearerr", "feof", "ferror",
  "perror",

  "isalnum", "isalpha", "iscntrl", "isdigit", "isgraph", "islower", "isprint",
  "ispunct", "isspace", "isupper", "isxdigit", "tolower", "toupper",

  "strcpy", "strncpy", "strcat", "strncat", "strcmp", "strncmp", "strchr",
  "strrchr", "strspn", "strcspn", "strpbrk", "strstr", "strlen", "strerror",
  "strtok", "memcpy", "memmove", "memcmp", "memchr", "memset",

  "sin", "cos", "tan", "asin", "acos", "atan",
  "atan2", "sinh", "cosh", "tanh", "exp", "log", "log10", "pow", "sqrt",
  "ceil", "floor", "fabs", "ldexp", "frexp", "modf", "fmod",
  "atof", "atoi", "atol", "strtod", "strtol", "strtoul", "rand",
  "srand",

  "calloc", "malloc", "realloc", "free", "abort", "exit", "atexit", "system",
  "getenv", "bsearch", "qsort", "abs", "labs",
  "div", "ldiv", "assert", "setjmp", "longjmp",

  "signal", "raise",
  "clock", "time", "difftime", "mktime", "asctime", "ctime", "gmtime",
  "localtime", "strftime",
  "strcoll", "strxfrm",
  "mbtowc", "mblen", "wctomb", "mbstowcs", "wcstombs",
  "setlocale", "localeconv",
  NULL
};
