/*JS*********************************************************************
*
*    Program : FILELEN
*    Language: ANSI-C
*    Author  : Joerg Schoen
*    Purpose : Get the file length.
*
*              Copyright (C) 1994-2002 Joerg Schoen
*
*   Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*
*************************************************************************/

/*********     INCLUDES                                         *********/
#include <jsconfig.h>

#include <jsllio.h>

/*********     DEFINES                                          *********/
/*  START-DEFINITIONS  */
#include <stdio.h>   /*	 For "FILE" definition    */
#include <jsllio.h>  /*	 For "off_t" definition    */
/*  END-DEFINITIONS  */

#define Prototype extern
/*********     PROTOTYPES                                       *********/
Prototype off_t          fileLength(const char *name);
Prototype off_t          fpFileLength(FILE *fp);
Prototype off_t          fdFileLength(int fd);

/*JS*********************************************************************
*
*************************************************************************/

off_t fileLength(const char *name)

/************************************************************************/
{
  struct stat stat_buf;

  if(stat(name, &stat_buf) == -1)
    return -1;

  return stat_buf.st_size;
}

/*JS*********************************************************************
*
*************************************************************************/

off_t fpFileLength(FILE *fp)

/************************************************************************/
{
  struct stat stat_buf;

  if(fstat(fileno(fp), &stat_buf) == -1)
    return -1;

  return stat_buf.st_size;
}

/*JS*********************************************************************
*
*************************************************************************/

off_t fdFileLength(int fd)

/************************************************************************/
{
  struct stat stat_buf;

  if(fstat(fd, &stat_buf) == -1)
    return -1;

  return stat_buf.st_size;
}
