/*JS*********************************************************************
*
*    Program : MYSTRDUP
*    Language: ANSI-C
*    Author  : Joerg Schoen
*    Purpose : Since "strdup" is neither ANSI nor POSIX conformant, I
*              supply my own routine to support systems that do not
*              provide this rather simple function.
*
*              Copyright (C) 1994-2002 Joerg Schoen
*
*   Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*
*************************************************************************/

/*********     INCLUDES                                         *********/
#include <stdlib.h>
#include <string.h>

#define Prototype extern
/*********     PROTOTYPES                                       *********/
Prototype char          *mystrdup(const char *s);

/*JS*********************************************************************
*
*************************************************************************/

char *mystrdup(const char *s)

/************************************************************************/
{
  char *string;

  string = (char *)malloc(strlen(s) + 1);

  if(string) strcpy(string, s);

  return(string);
}
