/*JS*********************************************************************
*
*    Program : STRICMP
*    Language: ANSI-C
*    Author  : Joerg Schoen
*    Purpose : Compare two strings -- case independent.
*
*              Copyright (C) 1994-2002 Joerg Schoen
*
*   Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*
*************************************************************************/

/*********     INCLUDES                                         *********/
#include <string.h>
#include <ctype.h>

/*********     DEFINES                                          *********/

#define Prototype extern
/*********     PROTOTYPES                                       *********/
Prototype int            jsstricmp(const char *s1, const char *s2);
Prototype int            jsstrincmp(const char *s1, const char *s2, size_t len);

/*JS*********************************************************************
*
*************************************************************************/

int jsstricmp(const char *s1, const char *s2)

/************************************************************************/
{
  register char c1, c2;

  while((c1 = tolower(*(unsigned char *)s1)) ==
	(c2 = tolower(*(unsigned char *)s2))) {
    if(c1 == '\0')
      return 0;

    s1++;  s2++;
  }

  return c1 - c2;
}

/*JS*********************************************************************
*
*************************************************************************/

int jsstrincmp(const char *s1, const char *s2, size_t len)

/************************************************************************/
{
  while(len-- > 0) {
    register char c1, c2;

    if((c1 = tolower(*(unsigned char *)s1)) !=
       (c2 = tolower(*(unsigned char *)s2)))
      return c1 - c2;

    if(c1 == '\0') return 0;

    s1++;  s2++;
  }

  return 0;
}
