/*JS*********************************************************************
*
*    Program : STRTOID
*    Language: ANSI-C
*    Author  : Joerg Schoen
*    Purpose : Similar to "strtol", but reads an C like identifier.
*
*              Copyright (C) 1994-2002 Joerg Schoen
*
*   Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*
*************************************************************************/

/*********     INCLUDES                                         *********/
#include <ctype.h>

#define Prototype extern
/*********     PROTOTYPES                                       *********/
Prototype long           jstrtoid(const char *input);

/*JS*********************************************************************
*   Returns the length of the C like identifier in input.
*************************************************************************/

long jstrtoid(const char *input)

/************************************************************************/
{
  const char *string;

  string = input;
  while(isalpha(*(unsigned char *)string) || *string == '_') {
    string++;

    while(isdigit(*(unsigned char *)string)) string++;
  }

  return string - input;
}

#ifdef TEST
int main(int argc, char *argv[])
{
  for(argv++ ; --argc > 0 ; argv++)
    printf("\"%s\": %d\n", *argv, jstrtoid(*argv));
  return 0;
}
#endif
