/*JS*********************************************************************
*
*    Program : UPDATECOL
*    Language: ANSI-C
*    Author  : Joerg Schoen
*    Purpose : Update how the column changes through the given characters
*
*              Copyright (C) 2004 Joerg Schoen
*
*   Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*
*************************************************************************/

/*********     INCLUDES 					*********/

/*********     DEFINES						*********/
#ifndef _WIN32
#define TABWIDTH     8  /*  UNIX etc.  */
#else
#define TABWIDTH     4  /*  Windows  */
#endif

#define Prototype extern
/*********     PROTOTYPES                                       *********/
Prototype int            updateColumn(int column, const char *string);

/*JS*********************************************************************
*
*************************************************************************/

int updateColumn(int column, const char *string)

/************************************************************************/
{
  int value;

  while((value = *string++) != '\0')
    if(value == '\t')
      column += TABWIDTH - (column % TABWIDTH);
    else if(value == '\r' || value == '\n')
      column = 0;
    else if(value != '\f') /*  '\f' does not advance the column  */
      ++column;

  return column;
}
