/*JS*********************************************************************
*
*    Program : SUPPWRAPPOSIX
*    Language: ANSI-C
*    Author  : Joerg Schoen
*    Purpose : Wrapper function for POSIX library routines (not yet
*              finished).
*
*              Copyright (C) 2005-2007 Joerg Schoen
*
*   Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*
*************************************************************************/

/*********     INCLUDES                                         *********/
#ifndef _WIN32
#include <dirent.h>
#endif

/*********     DEFINES                                          *********/
#define WRAPFUNCTION(name)   _jswrap_##name

/*********     PROTOTYPES                                       *********/
extern void _jstracefunc(const char *,const char *, ...);

#ifndef _WIN32
/*JS*********************************************************************
*   Functions from <dirent.h>
*************************************************************************/

DIR *WRAPFUNCTION(opendir)(const char *a)
{
  DIR *retvalue;

  _jstracefunc("+opendir","s",a);
  retvalue =  opendir(a);
  _jstracefunc("-opendir","p",retvalue);
  return retvalue;
}

void WRAPFUNCTION(rewinddir)(DIR *a)
{
  _jstracefunc("+rewinddir","p",a);
  rewinddir(a);
  _jstracefunc("-rewinddir","");
}

int WRAPFUNCTION(closedir)(DIR *a)
{
  int retvalue;

  _jstracefunc("+closedir","p",a);
  retvalue =  closedir(a);
  _jstracefunc("-closedir","i",retvalue);
  return retvalue;
}

struct dirent *WRAPFUNCTION(readdir)(DIR *a)
{
  struct dirent *retvalue;

  _jstracefunc("+readdir","p",a);
  retvalue =  readdir(a);
  _jstracefunc("-readdir","p",retvalue);
  return retvalue;
}
#else
void WRAPFUNCTION(notused_posix)(void)
{
}
#endif
