/*JS*********************************************************************
*
*    Program : SUPPWRAPSTD2
*    Language: ANSI-C
*    Author  : Joerg Schoen
*    Purpose : Wrapper function for standard library routines that
*              generate ugly warnings on Linux.
*
*              Copyright (C) 2005-2007 Joerg Schoen
*
*   Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*
*************************************************************************/

/*********     INCLUDES                                         *********/
#include <stdio.h>

/*********     DEFINES                                          *********/
#define WRAPFUNCTION(name)   _jswrap_##name

/*********     PROTOTYPES                                       *********/
extern void _jstracefunc(const char *,const char *, ...);

/*JS*********************************************************************
*   Functions from <stdio.h>
*************************************************************************/

char *WRAPFUNCTION(gets)(char *s)
{
  char *retvalue;

  _jstracefunc("+gets","s",s);
  retvalue =  gets(s);
  _jstracefunc("-gets","s",retvalue);
  return retvalue;
}

char *WRAPFUNCTION(tmpnam)(char *s)
{
  char *retvalue;

  _jstracefunc("+tmpnam","s",s);
  retvalue =  tmpnam(s);
  _jstracefunc("-tmpnam","s",retvalue);
  return retvalue;
}
