# /*
#
#   General test file for preprocessor. Define one of the symbols
#    TEST1 ... TESTn and run through jscpp.
#
#   This file may be used as a shell script as well (for SH).
#   This file contains solely tests of preprocessor extensions.
#

DIR=pptest2
if [ ! -d $DIR ] ; then
  mkdir $DIR
fi

#  Do all tests
max=2
i=1
while [ $i -le $max ] ; do
  echo -n " $i.."
  tfile=$DIR/test$i.i
  jscpp -DTEST$i PPTest2.c $* -o /tmp/tmp1$$
  sed '1d' </tmp/tmp1$$ >/tmp/tmp2$$

  if [ ! -r $tfile ] ; then
    echo "  --> Creating test file"
    cp /tmp/tmp2$$ $tfile
  elif ! cmp -s $tfile /tmp/tmp2$$ ; then
    echo ""
    diff $tfile /tmp/tmp2$$ || true
  fi
  i=`expr $i + 1`
done
echo ""
rm /tmp/tmp[12]$$
exit
# */

#if TEST1  /* --------------------------------------------------------- */
/*  Check predefined symbols  */
#ifndef __JSCPP__
#error Who on earth is that?
#endif

# ifdef __TIME_STAMP__
  Timestamp: "__TIMESTAMP__" is __TIMESTAMP__
# endif

# if defined(__INCLUDE_LEVEL__) && defined(__BASE_FILE__)
 /*  Reinclude itself to look at include level  */
  Include level: "__INCLUDE_LEVEL__" is __INCLUDE_LEVEL__
  Base file: "__BASE_FILE__" is __BASE_FILE__

#  undef TEST1
#  define TEST1_1 1
#  include __BASE_FILE__
# endif
#elif TEST1_1
  Include level: "__INCLUDE_LEVEL__" is __INCLUDE_LEVEL__
#  undef TEST1_1
#  define TEST1_2 1
#  include __BASE_FILE__
#elif TEST1_2
  Include level: "__INCLUDE_LEVEL__" is __INCLUDE_LEVEL__

#elif TEST2 /* --------------------------------------------------------- */
/*  Check "define_imm" command  */
#define mac1(x,y)  !x!y!a!
#define mac2(a,b)  ?x?y?a?b?
#define_imm  mac(a,b)  -- mac1(a,b) ++ mac1(X,Y) - a + b * mac2(u,v)
mac(mac1(V,W),mac2(U,V))
#undef mac1
#undef mac2
mac(here,how)

#endif
