# /*
#
#   General test file for expression detection. Run through "jscpp -m ftrace -D2".
#
#   This file may be used as a shell script as well (for SH).
#

DIR=test_expr
if [ ! -d $DIR ] ; then
  mkdir $DIR
fi

#  Do all tests
max=6
i=1
while [ $i -le $max ] ; do
  echo -n " $i.."
  tfile=$DIR/test$i.i

  jscpp -m ftrace -D2 -DTEST$i TestExpression.c -o /dev/null >/tmp/tmp$$

  if [ ! -r $tfile ] ; then
    echo "  --> Creating test file"
    cp /tmp/tmp$$ $tfile
  elif ! cmp -s $tfile /tmp/tmp$$ ; then
    echo ""
    diff $tfile /tmp/tmp$$ || true
  fi
  i=`expr $i + 1`
done
echo ""
rm /tmp/tmp$$
exit
# */

#ifdef __JSCPP__
#pragma __JSCPP__ notrace '*'
#endif

typedef int **INTPPTR;

struct bingo {
  int *a;
  double b;
};

typedef struct bingo *BINGO;

typedef union bongo {
  INTPPTR *ippptr;
} *BONGOPTR;

int main(void)
{
  char c;  short s;  int i;  long l;
  float f; double d;
  void *vptr;
  int *iptr;
  struct bingo str;
  BINGO biptr;
  INTPPTR ipptr;
  BONGOPTR bopptr;
  struct { int What; } wstr;

#if TEST1

  i = c * s;
  f = l - f;

#elif TEST2
  iptr = iptr + i;
  vptr = (void *)i;

#elif TEST3
  iptr = str.a;
  d = str.b;

  iptr = biptr->a;
  d = biptr->b;

#elif TEST4
  i = **ipptr;
  i = ***(bopptr->ippptr);

#elif TEST5
  iptr = &i;
  ipptr = &(str.a);
  ipptr = &(biptr->a);

#elif TEST6
  wstr = *((struct Bad1 { int Igitt; } *)vptr);
  wstr = *((struct { int Igitt; } *)vptr);

  i = ((struct Bad { int Igitt; } *)vptr)->Igitt;
#endif

  return 0;
}
