# /*
#   General test file for parser. Define one of the symbols
#    TEST1 ... TESTn and run through jscpp.
#
#   This file may be used as a shell script as well (for SH).
#

DIR=test_flow
if [ ! -d $DIR ] ; then
  mkdir $DIR
fi

#  Do all tests
max=6
i=1
while [ $i -le $max ] ; do
  echo -n " $i.."
  tfile=$DIR/test$i.i

  jscpp -m trace -DTEST$i -Xflowstmt -o /dev/null TestFlow.c >/tmp/tmp$$

  if [ ! -r $tfile ] ; then
    echo "  --> Creating test file"
    cp /tmp/tmp$$ $tfile
  elif ! cmp -s $tfile /tmp/tmp$$ ; then
    echo ""
    diff $tfile /tmp/tmp$$ || true
  fi
  i=`expr $i + 1`
done
echo ""
rm /tmp/tmp$$
exit
# */

/* ---------------------------------------------------------------------- */
#ifdef TEST1
int main()
{
  int a;
  a = 1;
  a;
  return a + 3;
  a, a + 1;
  (a + 1, -a);
  printf("",a);
}
#elif defined(TEST2)
int dummy(int a)
{
  0;
  1;
  if(a)
    3;
  else
    4;
  5;
  if(a) 7;
  if(!a) { 9; 10; }
  11;
}
#elif defined(TEST3)
int main(int argc,char *argv[])
{
  while(argc) 1;
  while(argc) {
    1;
    2;
  }

  do {
    3;
    if(argc) break;
    4;
    if(!argc) continue;
    5;
  } while(argc);

  while(argc) {
    7;
    if(argc) break;
    continue;
    11;
  }
  12;
}
#elif defined(TEST4)
int main(void)
{
  int i;
  for(      ;       ;      ) {}
  for(i = 1 ;       ;      ) {}
  for(      ; i = 2 ;      ) {}
  for(      ;       ; i = 3) {}

  for(i = 1 ; i = 2 ;      ) {}
  for(      ; i = 2 ; i = 3) {}
  for(i = 1 ;       ; i = 3) {}
  for(i = 1 ; i = 2 ; i = 3) {}
}
#elif defined(TEST5)
int main()
{
label1:
  1;
label2: label3:
  2;
label4:
  3;
}
#elif defined(TEST6)
int main(int argc, char *argv[])
{
  goto ONE;

  printf("HELLO\n");
ONE:
  for(1;argc;3) {
  }

  return 1;
}
#endif
